//041
//Einführen der Zeitschrittweite dt.

//Mittelwert omega=0.0348
//0.0485
//-0.0063
//LEDs:
//rot  A0+ A1-
//gelb A2+ A3-
//grün A4+ A5-

//A0 = D18
//A1 = D19
//A2 = D20
//A3 = D21
//A4 = D22
//A5 = D23

#include<math.h>
#include<Wire.h>

#include "Antrieb.h"
Antrieb antrieb;

//#define LL1 190000.0
//#define LL2 6000.0
#define LL1 110000.0
//#define LL2 10000.0
#define LL2 0.0

#define pa 0.0246580
#define pb 7.9769475
#define pc 280.08032

//Riccati-Parameter für Regelmatrix R
//#define r1 1.0
//#define r2 23.717595
//#define r3 0.6818306
//#define r4 0.064527

//optim: x0=[100    100    100    100]';
#define r1 6.314821    
#define r2 5657.5148    
#define r3 6.314821    
#define r4 4.331749

//x0=[100    100    100    100]';
//x0=[10    10    10    10]';
//#define r1 0.6314821    
//#define r2 977.79176    
//#define r3 0.6314821    
//#define r4 0.4331749

#define GYROSCALE 131.0
#define GYROOFFSET 2.71 //korrigierter Gyrooffset

//4.294.967.295  unsigned long
//    1.000.000  == 1s
//4.000.000.000  == 4000s
//1s == 1000ms == 1.000.000us


const int MPU=0x68;  // I2C address of the MPU-6050
int16_t AcX,AcY,AcZ,Tmp,GyX,GyY,GyZ;

double ax,ay,az;
double arx,ary,arz,arx_alt;

double gam,phi,ome,alf; //Simulations-Zustände

double wx,wy,wz; //Winkelgeschwindigkeiten

double stellgroesse;

unsigned long ZEIT_MIKROSEKUNDE;     //Hilfsvariablen zur Bestimmung von dt unter Verwendung von 
unsigned long ZEIT_ALT_MIKROSEKUNDE;
double dt=0.0;

void rot()
{
    digitalWrite(18,1);  
    digitalWrite(20,0);  
    digitalWrite(22,0);  
}

void gelb()
{
    digitalWrite(18,0);  
    digitalWrite(20,1);  
    digitalWrite(22,0);  
}

void gruen()
{
    digitalWrite(18,0);  
    digitalWrite(20,0);  
    digitalWrite(22,1);  
}

void aus()
{
    digitalWrite(18,0);  
    digitalWrite(20,0);  
    digitalWrite(22,0);  
}

void rotgruengelb()
{
    digitalWrite(18,1);  
    digitalWrite(20,1);  
    digitalWrite(22,1);  
}



void setup() 
{
  
//  pinMode(0,INPUT);  

  pinMode(0,OUTPUT);  
  digitalWrite(0,0); //AD0 auf Masse
  
  pinMode(1,INPUT);  
 // pinMode(2,INPUT);  SDA
 // pinMode(3,INPUT);  SCL
  pinMode(4,INPUT);  //GND für MPU6050
//  pinMode(4,OUTPUT);  //GND für MPU6050
//  digitalWrite(4,0);
  
  pinMode(5,INPUT);  
  pinMode(6,INPUT);  
  pinMode(7,INPUT);  
  pinMode(8,INPUT);  
  pinMode(9,INPUT);  
  pinMode(10,INPUT);  
  pinMode(11,INPUT);  
  pinMode(12,INPUT);  
  pinMode(13,INPUT);  
  // put your setup code here, to run once:
  Wire.begin();
  Wire.beginTransmission(MPU);
  Wire.write(0x6B);  // PWR_MGMT_1 register
  Wire.write(0);     // set to zero (wakes up the MPU-6050)
  Wire.endTransmission(true);
  Serial.begin(9600);

  pinMode(18,OUTPUT);  
  pinMode(19,OUTPUT);  
  pinMode(20,OUTPUT);  
  pinMode(21,OUTPUT);  
  pinMode(22,OUTPUT);  
  pinMode(23,OUTPUT);  

  digitalWrite(18,0);
  digitalWrite(19,0);
  digitalWrite(20,0);
  digitalWrite(21,0);
  digitalWrite(22,0);
  digitalWrite(23,0);
  
  antrieb.start();    

  arx_alt=0.0;  
  
  ZEIT_MIKROSEKUNDE = micros();     //Hilfsvariablen zur Bestimmung von dt unter Verwendung von 
  ZEIT_ALT_MIKROSEKUNDE = ZEIT_MIKROSEKUNDE;     //Hilfsvariablen zur Bestimmung von dt unter Verwendung von 
  dt = (double)(ZEIT_MIKROSEKUNDE-ZEIT_ALT_MIKROSEKUNDE)*0.000001;

  gam = 0.0;
  phi = 0.0;
  ome = 0.0;
  alf = 0.0; //Simulations-Zustände

  //Serial.begin(9600);  
}

void loop() 
{
  // put your main code here, to run repeatedly:
  Wire.beginTransmission(MPU);
  Wire.write(0x3B);  // starting with register 0x3B (ACCEL_XOUT_H)
  Wire.endTransmission(false);
  //Wire.requestFrom(MPU,14,true);  // request a total of 14 registers
  Wire.requestFrom(MPU,6,true);  // request a total of 14 registers
  AcX=Wire.read()<<8|Wire.read();  // 0x3B (ACCEL_XOUT_H) & 0x3C (ACCEL_XOUT_L)     
  AcY=Wire.read()<<8|Wire.read();  // 0x3D (ACCEL_YOUT_H) & 0x3E (ACCEL_YOUT_L)
  AcZ=Wire.read()<<8|Wire.read();  // 0x3F (ACCEL_ZOUT_H) & 0x40 (ACCEL_ZOUT_L)
  //Tmp=Wire.read()<<8|Wire.read();  // 0x41 (TEMP_OUT_H) & 0x42 (TEMP_OUT_L)
  //GyX=Wire.read()<<8|Wire.read();  // 0x43 (GYRO_XOUT_H) & 0x44 (GYRO_XOUT_L)
  //GyY=Wire.read()<<8|Wire.read();  // 0x45 (GYRO_YOUT_H) & 0x46 (GYRO_YOUT_L)
  //GyZ=Wire.read()<<8|Wire.read();  // 0x47 (GYRO_ZOUT_H) & 0x48 (GYRO_ZOUT_L)
  
  //Berechnung des Winkels (Datenblatt, S.7):
  //phi_x = atan(ax/sqrt(ay*ay+az*az))
  //phi_y = atan(ay/sqrt(ax*ax+az*az))
  //phi_z = atan(az/sqrt(ay*ay+ax*ax))
  
  // calculate accelerometer angles
  ax = (double)AcX;
  ay = (double)AcY;
  az = (double)AcZ;  

  arx = ax / sqrt(ay*ay + az*az); 
  //arx = atan(arx);

  //wz = GYROOFFSET + (double)GyZ/GYROSCALE + 0.1014;
  //wz*=0.01;


  if(arx>arx_alt+0.03 || arx<arx_alt-0.03)
      arx = 0.82*arx_alt + 0.18*arx;

  arx_alt = arx;

  ZEIT_MIKROSEKUNDE = micros();     //Hilfsvariablen zur Bestimmung von dt unter Verwendung von 
  dt = (double)(ZEIT_MIKROSEKUNDE-ZEIT_ALT_MIKROSEKUNDE)*0.000001;  
  ZEIT_ALT_MIKROSEKUNDE = ZEIT_MIKROSEKUNDE;  

  stellgroesse = -r1*gam -r2*phi - r3*ome - r4*alf;

//  Serial.println(stellgroesse);

  if(stellgroesse>480.0)
      stellgroesse=480.0;
  if(stellgroesse<-480.0)
      stellgroesse=-480.0;

  //Simulationsschritt:
  alf += ( (-pc/pa)*ome + (-pb/pa)*alf + (1.0/pa)*(stellgroesse+LL1*(arx-phi)+LL2*(wz-ome)) )*dt; //Simulations-Zustände
  ome += alf*dt;
  phi += ome*dt;
  gam += phi*dt;


  if(arx<-0.7 || arx>0.7)
  {
      rot();
      antrieb.links(-20);
      antrieb.rechts(20);
      ZEIT_MIKROSEKUNDE = micros();     //Hilfsvariablen zur Bestimmung von dt unter Verwendung von 
      ZEIT_ALT_MIKROSEKUNDE = ZEIT_MIKROSEKUNDE;     //Hilfsvariablen zur Bestimmung von dt unter Verwendung von 
      dt = (double)(ZEIT_MIKROSEKUNDE-ZEIT_ALT_MIKROSEKUNDE)*0.000001;
      gam = 0.0;
      phi = 0.0;
      ome = 0.0;
      alf = 0.0; //Simulations-Zustände

  }
  else
  {
      gruen();
      antrieb.links((int)stellgroesse-20);
      antrieb.rechts((int)stellgroesse+20);      
  }  
}
