//Der Einachser soll hier mit den in Scilab optimierten
//Werten für einen PI-Regler getestet werden.

//Um den I-Anteil korrekt aufsummieren zu können, 
//ist es notwendig, die Zeitschrittweite dt eines Schleifendurchlaufes zu berechnen (s.u.)

//Mittelwert omega=0.0348
//0.0485
//-0.0063
//LEDs:
//rot  A0+ A1-
//gelb A2+ A3-
//grün A4+ A5-

//A0 = D18
//A1 = D19
//A2 = D20
//A3 = D21
//A4 = D22
//A5 = D23

#include<math.h>
#include<Wire.h>

//Optimierung ohne Rauschen, ohne Totzeit aber mit Stellgrößenbegrenzung:
#define P_ANTEIL 1956.4263 
#define I_ANTEIL 166.4572
//Optimierung mit Rauschen, Totzeit und Stellgrößenbegrenzung:
//#define P_ANTEIL 3200.0
//#define I_ANTEIL 200.0




#define GYROSCALE 131.0
//#define GYROOFFSET 2.75
#define GYROOFFSET 2.71 //korrigierter Gyrooffset

//4.294.967.295  unsigned long
//    1.000.000  == 1s
//4.000.000.000  == 4000s
//1s == 1000ms == 1.000.000us


const int MPU=0x68;  // I2C address of the MPU-6050
int16_t AcX,AcY,AcZ,Tmp,GyX,GyY,GyZ;

double ax,ay,az;
double arx,ary,arz,arx_alt;

double wx,wy,wz; //Winkelgeschwindigkeiten

double integ_arx=0.0;
//double integ_wz=0.0;

double stellgroesse;

boolean SERIELL = false;

double m=0.0;
double dt=0.0; //Zeitschrittweite in Sekunden - wird in jeder Loop neu berechnet.

unsigned long ZEIT_MIKROSEKUNDE;     //Hilfsvariablen zur Bestimmung von dt unter Verwendung von 
unsigned long ZEIT_ALT_MIKROSEKUNDE;

#include "Antrieb.h"

Antrieb antrieb;

void rot()
{
    digitalWrite(18,1);  
    digitalWrite(20,0);  
    digitalWrite(22,0);  
}

void gelb()
{
    digitalWrite(18,0);  
    digitalWrite(20,1);  
    digitalWrite(22,0);  
}

void gruen()
{
    digitalWrite(18,0);  
    digitalWrite(20,0);  
    digitalWrite(22,1);  
}

void aus()
{
    digitalWrite(18,0);  
    digitalWrite(20,0);  
    digitalWrite(22,0);  
}

void rotgruengelb()
{
    digitalWrite(18,1);  
    digitalWrite(20,1);  
    digitalWrite(22,1);  
}



void setup() 
{
  
//  pinMode(0,INPUT);  

  pinMode(0,OUTPUT);  
  digitalWrite(0,0); //AD0 auf Masse
  
  pinMode(1,INPUT);  
 // pinMode(2,INPUT);  SDA
 // pinMode(3,INPUT);  SCL
  pinMode(4,INPUT);  //GND für MPU6050
//  pinMode(4,OUTPUT);  //GND für MPU6050
//  digitalWrite(4,0);
  
  pinMode(5,INPUT);  
  pinMode(6,INPUT);  
  pinMode(7,INPUT);  
  pinMode(8,INPUT);  
  pinMode(9,INPUT);  
  pinMode(10,INPUT);  
  pinMode(11,INPUT);  
  pinMode(12,INPUT);  
  pinMode(13,INPUT);  
  // put your setup code here, to run once:
 Wire.begin();
  Wire.beginTransmission(MPU);
  Wire.write(0x6B);  // PWR_MGMT_1 register
  Wire.write(0);     // set to zero (wakes up the MPU-6050)
  Wire.endTransmission(true);
  Serial.begin(9600);

  pinMode(18,OUTPUT);  
  pinMode(19,OUTPUT);  
  pinMode(20,OUTPUT);  
  pinMode(21,OUTPUT);  
  pinMode(22,OUTPUT);  
  pinMode(23,OUTPUT);  

  digitalWrite(18,0);
  digitalWrite(19,0);
  digitalWrite(20,0);
  digitalWrite(21,0);
  digitalWrite(22,0);
  digitalWrite(23,0);
  
  antrieb.start();    

  arx_alt=0.0;  
  
  ZEIT_MIKROSEKUNDE = micros();
  ZEIT_ALT_MIKROSEKUNDE = ZEIT_MIKROSEKUNDE;
}

void loop() 
{
  // put your main code here, to run repeatedly:
  Wire.beginTransmission(MPU);
  Wire.write(0x3B);  // starting with register 0x3B (ACCEL_XOUT_H)
  Wire.endTransmission(false);
//  Wire.requestFrom(MPU,14,true);  // request a total of 14 registers
  Wire.requestFrom(MPU,6,true);  // request a total of 14 registers
  AcX=Wire.read()<<8|Wire.read();  // 0x3B (ACCEL_XOUT_H) & 0x3C (ACCEL_XOUT_L)     
  AcY=Wire.read()<<8|Wire.read();  // 0x3D (ACCEL_YOUT_H) & 0x3E (ACCEL_YOUT_L)
  AcZ=Wire.read()<<8|Wire.read();  // 0x3F (ACCEL_ZOUT_H) & 0x40 (ACCEL_ZOUT_L)
//  Tmp=Wire.read()<<8|Wire.read();  // 0x41 (TEMP_OUT_H) & 0x42 (TEMP_OUT_L)
//  GyX=Wire.read()<<8|Wire.read();  // 0x43 (GYRO_XOUT_H) & 0x44 (GYRO_XOUT_L)
//  GyY=Wire.read()<<8|Wire.read();  // 0x45 (GYRO_YOUT_H) & 0x46 (GYRO_YOUT_L)
//  GyZ=Wire.read()<<8|Wire.read();  // 0x47 (GYRO_ZOUT_H) & 0x48 (GYRO_ZOUT_L)
  
  //Berechnung des Winkels (Datenblatt, S.7):
  //phi_x = atan(ax/sqrt(ay*ay+az*az))
  //phi_y = atan(ay/sqrt(ax*ax+az*az))
  //phi_z = atan(az/sqrt(ay*ay+ax*ax))
  
  // calculate accelerometer angles
  ax = (double)AcX;
  ay = (double)AcY;
  az = (double)AcZ;
  
  arx = ax / sqrt(ay*ay + az*az); 


  if(arx>arx_alt+0.03 || arx<arx_alt-0.03)
//      arx = 0.85*arx_alt + 0.15*arx;
      arx = 0.82*arx_alt + 0.18*arx;
//      arx = 0.85*arx_alt + 0.15*arx;


stellgroesse = P_ANTEIL*arx + I_ANTEIL*integ_arx;

  arx_alt = arx;

//Antiwindup:

/*
if(stellgroesse>480.0 && integ_arx>0.0)
{
    m = stellgroesse-480.0;
    if(integ_arx>m*0.2)
        integ_arx-=m*0.2;
}

if(stellgroesse<-480.0 && integ_arx<0.0)
{
    m = stellgroesse+480.0;
    if(integ_arx<m*0.2)
        integ_arx-=m*0.2;
}
*/

  ZEIT_MIKROSEKUNDE = micros();     //Hilfsvariablen zur Bestimmung von dt unter Verwendung von 
  dt = (double)(ZEIT_MIKROSEKUNDE-ZEIT_ALT_MIKROSEKUNDE)*0.000001;


  integ_arx+=arx*dt;
  
  ZEIT_ALT_MIKROSEKUNDE = ZEIT_MIKROSEKUNDE;  
//  integ_wz+=wz;

  if(stellgroesse>480.0)
      stellgroesse=480.0;
  if(stellgroesse<-480.0)
      stellgroesse=-480.0;

  if(SERIELL)
  {
      Serial.println(" Berechnete Daten ohne atan: ");
      Serial.print(" arx = "); Serial.println(arx,DEC);
      Serial.print(" wz = "); Serial.println(wz,DEC);
      Serial.print(" stellgroesse = "); Serial.println(stellgroesse,DEC);
      delay(333);
  }

  if(arx<-0.7 || arx>0.7) //Deaktivieren des Fahrzeugs in "Rückenlage"
  {
      rot();
      antrieb.links(-20);
      antrieb.rechts(20);
      integ_arx=0.0;
  }
  else
  {
      gruen();
      antrieb.links((int)stellgroesse-20);
      antrieb.rechts((int)stellgroesse+20);      
  }
  
  //Auswertung:
  //es wird nur wz und arx benötigt
  //Drehung in Fahrtrichtung: wz<0 (Mathematisch positiver Sinn)
  //Verkippung in Fahrtrichtung: arx<0 (Mathematisch positiver Sinn)
  //OFFSET wz: ungefähr -2.6
}
